/*
 * cmd.c
 *
 * Wrapper of the MatLab Engine API engEvalString
 * for call from Mathematica
 *
 * Revision 2003.3.11
 *
 * Robert
 *	
 */

#include "mathlink.h"
#include "engine.h"
#include <string.h>

#define  BUFSIZE (32*1024-1)	//32k for output buffer. This gets zeroed at each call, so don't make it too big.

extern Engine* Eng;
extern void msg(const char* m);

void engcmd(const char* command)
{
	char buffer[BUFSIZE+1];	//MatLab output buffer
    memset(buffer, 0, (BUFSIZE+1)*sizeof(char)); // this is necessary as the string returned by MATLAB is NOT necessarily 0-terminated!

    bool SUCCESS = true;		//success flag

	if (NULL == Eng)	//if not opened yet
	{
		msg("eng::noMLB");	//message 
		SUCCESS = false;
	}
	else
	{
		engOutputBuffer(Eng, buffer, BUFSIZE);	//for return output //leave the last "0" in any case
		//issue command
		if(engEvalString(Eng, command))	//if unsucessful
		{
			msg("engCmd::erexe");
			SUCCESS = false;
		}
	}

    if(SUCCESS) {
        int offset = 0;
        if ((BUFSIZE >= 3) && (buffer[0] == '>') && (buffer[1] == '>') && (buffer[2] == ' ')) {
            // remove the '>> ' prefix if it exists (seems to happen only under Linux)
            offset = 3;
        }
        //JAN
		MLPutByteString(stdlink, (const unsigned char*)/*JAN*/(buffer+offset), strlen(buffer+offset));
    } else {
		MLPutSymbol(stdlink, "$Failed");
    }
}
