(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     37155,       1098]
NotebookOptionsPosition[     31496,        908]
NotebookOutlinePosition[     31966,        926]
CellTagsIndexPosition[     31923,        923]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["mConnect Documentation", "Title",
 CellChangeTimes->{{3.451139982171875*^9, 3.451139985046875*^9}, {
  3.478852855947826*^9, 3.478852857835429*^9}}],

Cell["Overview", "Subtitle",
 CellChangeTimes->{{3.4788525655221157`*^9, 3.4788525667701178`*^9}}],

Cell["\<\
mConnect is a Mathematica/MathLink application to allow integration of MATLAB \
code and sharing of data between Mathematica and MATLAB.\
\>", "Text",
 CellChangeTimes->{{3.4788528651674423`*^9, 3.4788528676790466`*^9}}],

Cell[CellGroupData[{

Cell["Author", "Subtitle",
 CellChangeTimes->{{3.478852493552389*^9, 3.478852494425991*^9}}],

Cell["\<\
Jan Lellmann, Jan.Lellmann@web.de. mConnect is based on mEngine Version 0.61 \
by Robert, zhangchenhui99@mails.tsinghua.edu.cn.\
\>", "Text",
 CellChangeTimes->{{3.478852512958823*^9, 3.4788525511476903`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Installation", "Subtitle",
 CellChangeTimes->{{3.451139986296875*^9, 3.45113998725*^9}}],

Cell["Windows", "Subsubtitle",
 CellChangeTimes->{{3.451899360522976*^9, 3.451899372577255*^9}}],

Cell[TextData[{
 "To install,\n1. find your ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " application directory (the one with \"Applications\", \"Autoload\", \
\"FrontEnd\" etc. in it). Usually it is something like <",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ">\\AddOns\\Applications. The directory can be moved by setting the \
MATHEMATICA_USERBASE environment variable.\n2. copy mConnect.m and *.mathlink \
into this folder."
}], "Text",
 CellChangeTimes->{{3.451143855640625*^9, 3.451143956046875*^9}, {
  3.451145626546875*^9, 3.4511456573125*^9}, {3.451899397293232*^9, 
  3.451899399834708*^9}, {3.4788527390100203`*^9, 3.478852754594448*^9}, {
  3.4788527879629064`*^9, 3.478852806448939*^9}}],

Cell[CellGroupData[{

Cell["Linux", "Subsubtitle",
 CellChangeTimes->{{3.451899350901635*^9, 3.451899378582312*^9}}],

Cell[TextData[{
 "To install,\n1. Append Matlab's bin/glnx86 (or the corresponding folder for \
64 bit systems) to your LD_LIBRARY_PATH.\n2. build the ",
 StyleBox["MathLink",
  FontSlant->"Italic"],
 " executable (or skip this step and try to use the pre-built executables):\n\
2.a) run \"make\" from within the \"src\" folder \n2.b) spend some time \
resolving all nasty linker errors and setting the correct paths to ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " and Matlab in \"Makefile\". \n3. copy (or better, link using \"ln -s\") \
mConnect.m and *.mathlink to your ~/.",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "/Applications directory (or the directory specified in MATHEMATICA_USERBASE \
in case it is set). This can be done automatically by \"make install\" in the \
\"src\" folder; the links can be removed by \"make uninstall\". Do not move \
the \"mConnect/src\" folder afterwards, as this will break the links."
}], "Text",
 CellChangeTimes->{{3.451899379853355*^9, 3.451899699840181*^9}, {
  3.451903891078982*^9, 3.451903975354084*^9}, {3.478852432010281*^9, 
  3.4788524657375402`*^9}, {3.4788528108325467`*^9, 3.478852844481806*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Managing the MATLAB connection", "Subtitle",
 CellChangeTimes->{{3.451144031984375*^9, 3.45114403496875*^9}, {
  3.451144121296875*^9, 3.451144124828125*^9}, {3.4511444728125*^9, 
  3.451144494390625*^9}, {3.45114704215625*^9, 3.451147043421875*^9}}],

Cell[TextData[{
 "mConnect can now be accessed from any ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " document by"
}], "Text",
 CellChangeTimes->{{3.451143964734375*^9, 3.451143972140625*^9}, {
  3.4511440145625*^9, 3.451144028671875*^9}}],

Cell[BoxData[
 RowBox[{"<<", "mConnect`"}]], "Input",
 CellChangeTimes->{{3.451139883234375*^9, 3.451139921203125*^9}, 
   3.45114384975*^9, {3.4511440415625*^9, 3.4511440458125*^9}, {
   3.451144111546875*^9, 3.451144149984375*^9}, {3.451144194828125*^9, 
   3.451144199859375*^9}}],

Cell["The MATLAB instance is started manually using", "Text",
 CellChangeTimes->{{3.451144203578125*^9, 3.4511442468125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"engOpen", "[", "]"}]], "Input",
 CellChangeTimes->{{3.45114420171875*^9, 3.451144220296875*^9}, {
  3.45191327720881*^9, 3.451913279037385*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"eng", "::", "\<\"stMLB\"\>"}], ":", 
  " ", "\<\"Starting MATLAB...\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.451913279407317*^9}]
}, Open  ]],

Cell["\<\
The MATLAB window is hidden by default; it can be made visible for debugging \
purposes by\
\>", "Text",
 CellChangeTimes->{{3.451144316734375*^9, 3.45114433115625*^9}}],

Cell[BoxData[
 RowBox[{"mShow", "[", "]"}]], "Input",
 CellChangeTimes->{{3.451144332109375*^9, 3.45114433340625*^9}}],

Cell["\<\
(note that this doesn't seem to work under Linux yet) and hidden again by\
\>", "Text",
 CellChangeTimes->{{3.451144341484375*^9, 3.451144343578125*^9}, {
  3.451899284604404*^9, 3.451899299847207*^9}}],

Cell[BoxData[
 RowBox[{"mHide", "[", "]"}]], "Input",
 CellChangeTimes->{{3.451144336859375*^9, 3.451144347453125*^9}}],

Cell["Closing the engine:", "Text",
 CellChangeTimes->{{3.451144379328125*^9, 3.451144389375*^9}}],

Cell[BoxData[
 RowBox[{"engClose", "[", "]"}]], "Input",
 CellChangeTimes->{{3.451144409265625*^9, 3.4511444490625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sending MATLAB commands", "Subtitle",
 CellChangeTimes->{{3.4511444990625*^9, 3.451144505890625*^9}, {
  3.45114703875*^9, 3.451147040125*^9}}],

Cell["\<\
mCmd evaluates a MATLAB command and returns the text output in string form. \
The engine is automatically loaded if not done yet:\
\>", "Text",
 CellChangeTimes->{{3.451144513890625*^9, 3.451144571*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mCmd", "[", "\"\<disp('Hello Mathematica!');\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.45114457203125*^9, 3.4511445835625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"eng", "::", "\<\"stMLB\"\>"}], ":", 
  " ", "\<\"Starting MATLAB...\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.451144583875*^9, 3.451144677265625*^9, 
  3.451145751109375*^9, 3.451146261484375*^9, 3.45114706340625*^9, 
  3.451899307422856*^9, 3.451913295525923*^9}],

Cell[BoxData["\<\"Hello Mathematica!\\n\"\>"], "Output",
 CellChangeTimes->{3.4511445850625*^9, 3.451144678484375*^9, 
  3.45114575684375*^9, 3.451146263171875*^9, 3.451147063546875*^9, 
  3.451899315712134*^9, 3.451913303628094*^9}]
}, Open  ]],

Cell["Errors in the output are reported and $Failed is returned.", "Text",
 CellChangeTimes->{{3.451144592046875*^9, 3.4511446338125*^9}, {
  3.45114468346875*^9, 3.451144683546875*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mCmd", "[", "\"\<invalid statement\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.451144589578125*^9, 3.45114461128125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mCmd", "::", "\<\"matlaberror\"\>"}], ":", 
  " ", "\<\"MATLAB command failed, errors:\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.451913305170998*^9, 3.451913414408374*^9}],

Cell[BoxData["\<\"??? Undefined function or method 'invalid' for input \
arguments of type 'char'. [MATLAB:UndefinedFunction]\\n\"\>"], "Print",
 CellChangeTimes->{3.451913305201976*^9, 3.451913414424878*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mCmd", "::", "\<\"matlaberroroutput\"\>"}], ":", 
  " ", "\<\"Full output of failed MATLAB command:\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.451913305170998*^9, 3.451913414438408*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.451913305201976*^9, 3.451913414446298*^9}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.451144611765625*^9, 3.4511446799375*^9, 
  3.451145757140625*^9, 3.451146263421875*^9, 3.4511470635625*^9, 
  3.451899321352028*^9, 3.4519133052224*^9, 3.451913414454553*^9}]
}, Open  ]],

Cell["\<\
The last MATLAB error can be retrieved in string form by mGetLastError[] and \
cleared using mClearLastError[]:\
\>", "Text",
 CellChangeTimes->{{3.451913384046587*^9, 3.451913440054061*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"mGetLastError", "[", "]"}], "\[IndentingNewLine]", 
 RowBox[{"mClearLastError", "[", "]"}], "\[IndentingNewLine]", 
 RowBox[{"mGetLastError", "[", "]"}]}], "Input",
 CellChangeTimes->{{3.451913407556865*^9, 3.451913409725573*^9}, {
  3.451913442321864*^9, 3.451913449213406*^9}}],

Cell[BoxData["\<\"??? Undefined function or method 'invalid' for input \
arguments of type 'char'. [MATLAB:UndefinedFunction]\\n\"\>"], "Output",
 CellChangeTimes->{{3.4519134105931*^9, 3.45191341605802*^9}, 
   3.451913449695611*^9}],

Cell[BoxData["\<\"\"\>"], "Output",
 CellChangeTimes->{{3.4519134105931*^9, 3.45191341605802*^9}, 
   3.451913449711667*^9}],

Cell[BoxData["\<\"\"\>"], "Output",
 CellChangeTimes->{{3.4519134105931*^9, 3.45191341605802*^9}, 
   3.451913449904501*^9}]
}, Open  ]],

Cell["\<\
To temporarily put variables into the Matlab workspace during the evaluation \
of a command, just separate them by colons as you would in a \"Print\" \
statement.\
\>", "Text",
 CellChangeTimes->{{3.451144718859375*^9, 3.45114475621875*^9}, {
  3.45114486940625*^9, 3.451144869828125*^9}, {3.451913457259949*^9, 
  3.451913459388008*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"mCmd", "[", 
  RowBox[{"\"\<disp(\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}], ",", "\"\<+\>\"", ",", "a", ",", 
   "\"\<);\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.451144759703125*^9, 3.4511448531875*^9}}],

Cell[BoxData["\<\"     3\\n     6\\n\\n\"\>"], "Output",
 CellChangeTimes->{3.45114485665625*^9, 3.451145757171875*^9, 
  3.451146263453125*^9, 3.451147063578125*^9, 3.451913315248996*^9, 
  3.451913460661063*^9}]
}, Open  ]],

Cell["\<\
This works for all (scalar and multidimensional) numeric array types with the \
exception of strings. To pass a string, use mVar[]:\
\>", "Text",
 CellChangeTimes->{{3.451144860625*^9, 3.451144957359375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"s", " ", "=", " ", "\"\<MATLAB\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"mCmd", "[", 
  RowBox[{"\"\<disp(['Hello ' \>\"", ",", 
   RowBox[{"mVar", "[", "s", "]"}], ",", "\"\<]);\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.4511449604375*^9, 3.451145013015625*^9}}],

Cell[BoxData["\<\"Hello MATLAB\\n\"\>"], "Output",
 CellChangeTimes->{{3.451144991578125*^9, 3.451145013421875*^9}, 
   3.45114575721875*^9, 3.451146263453125*^9, 3.45114706359375*^9, 
   3.451913316937719*^9, 3.451913463485697*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sending MATLAB commands with output", "Subtitle",
 CellChangeTimes->{{3.4511444990625*^9, 3.451144505890625*^9}, {
  3.45114703875*^9, 3.451147040125*^9}, {3.475156785857422*^9, 
  3.4751567868964844`*^9}}],

Cell["\<\
Use mGetCmd to return the result of a command with a single output argument:\
\>", "Text",
 CellChangeTimes->{{3.475156793685547*^9, 3.475156818029297*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"mGetCmd", "[", "\"\<['Time: ' num2str(tic)]\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mGetCmd", "[", "\"\<rand(2,4)\>\"", "]"}], " ", "//", " ", 
  "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.475156791951172*^9, 3.475156825138672*^9}, {
  3.4751568793183594`*^9, 3.4751568864121094`*^9}, {3.4751569167714844`*^9, 
  3.4751569733027344`*^9}}],

Cell[BoxData["\<\"Time: 417248097895\"\>"], "Output",
 CellChangeTimes->{
  3.475156825482422*^9, {3.475156881466797*^9, 3.4751568866308594`*^9}, {
   3.475156926498047*^9, 3.4751569735527344`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.9571669482429456`", "0.8002804688888001`", "0.421761282626275`", 
      "0.7922073295595544`"},
     {"0.4853756487228412`", "0.14188633862721534`", "0.9157355251890671`", 
      "0.959492426392903`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.475156825482422*^9, {3.475156881466797*^9, 3.4751568866308594`*^9}, {
   3.475156926498047*^9, 3.4751569735839844`*^9}}]
}, Open  ]],

Cell["mGetCmd does not work with multiple commands:", "Text",
 CellChangeTimes->{{3.475156900169922*^9, 3.4751569050214844`*^9}}],

Cell[BoxData[
 RowBox[{"mGetCmd", "[", "\"\<start = tic; start\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.475156896419922*^9, 3.475156908029297*^9}, {
  3.475156983216797*^9, 3.475157019513672*^9}}],

Cell["\<\
To return the result of a command with multiple output arguments, use \
mGetCmdList and specify the number of output arguments:\
\>", "Text",
 CellChangeTimes->{{3.475157029654297*^9, 3.475157044326172*^9}, {
  3.4751570747646484`*^9, 3.475157081538086*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mGetCmdList", "[", 
  RowBox[{
  "3", ",", "\"\<deal('This command has',3,'output arguments.')\>\""}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4751570275214844`*^9, 3.475157111366211*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"This command has\"\>", ",", "3.`", 
   ",", "\<\"output arguments.\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.475157088913086*^9, 3.4751571116083984`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Transferring data from MATLAB to ",
 StyleBox["Mathematica ",
  FontSlant->"Italic"],
 "manually"
}], "Subtitle",
 CellChangeTimes->{{3.451145134828125*^9, 3.45114514778125*^9}, {
  3.451147005765625*^9, 3.4511470200625*^9}, {3.475156632873047*^9, 
  3.475156646169922*^9}}],

Cell["\<\
You can use mGet to transfer the contents of existing top-level variables \
directly:\
\>", "Text",
 CellChangeTimes->{{3.451145152203125*^9, 3.45114519590625*^9}, {
  3.475156653904297*^9, 3.4751566849433594`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mCmd", "[", "\"\<t = tic;\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"mGet", "[", "\"\<t\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.451145202046875*^9, 3.4511452476875*^9}}],

Cell[BoxData["6.140863772912253`*^-309"], "Output",
 CellChangeTimes->{3.451145222609375*^9, 3.45114575725*^9, 
  3.45114626346875*^9, 3.451147063609375*^9, 3.451913319746217*^9, 
  3.451913465026097*^9}]
}, Open  ]],

Cell["In contrast to mGetCmd, mGet does not work with expressions:", "Text",
 CellChangeTimes->{{3.475156692201172*^9, 3.475156704857422*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"mGet", "[", "\"\<5\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mCmd", "[", "\"\<a.b = 1;\>\"", "]"}], ";", 
  RowBox[{"mGet", "[", "\"\<a.b\>\"", "]"}]}]}], "Input",
 CellChangeTimes->{{3.4751566903652344`*^9, 3.475156757904297*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"engGet", "::", "\<\"erget\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Error getting array from the \
MATLAB workspace. Array may not exist.\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{{3.475156710748047*^9, 3.475156758654297*^9}}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{{3.4751567110371094`*^9, 3.475156758654297*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"engGet", "::", "\<\"erget\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Error getting array from the \
MATLAB workspace. Array may not exist.\\\\\\\"\\\", \\\"MT\\\"]\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{{3.475156710748047*^9, 3.4751567586777344`*^9}}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{{3.4751567110371094`*^9, 3.4751567586777344`*^9}}]
}, Open  ]],

Cell["\<\
If the result is not needed anymore, free the memory using clear:\
\>", "Text",
 CellChangeTimes->{{3.4511452498125*^9, 3.45114526321875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mCmd", "[", "\"\<clear t;\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.451145265015625*^9, 3.451145270875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Transferring data from ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " to MATLAB manually"
}], "Subtitle",
 CellChangeTimes->{{3.45114527809375*^9, 3.451145289484375*^9}, {
  3.451147024796875*^9, 3.451147031765625*^9}}],

Cell[TextData[{
 "When values are passed using the mCmd inline syntax, the corresponding \
MATLAB variables are automatically removed after the function call. If they \
must be accessed several time, it may be faster to transfer them manually \
once using mPut.\nThe \"string\" syntax creates a new variable in the MATLAB \
workspace with the same name as the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " variable:"
}], "Text",
 CellChangeTimes->{{3.4511452909375*^9, 3.451145405265625*^9}, {
  3.45114544925*^9, 3.45114549146875*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"hugeArray", " ", "=", " ", 
   RowBox[{"ConstantArray", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "20", ",", "40"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mPut", "[", "\"\<hugeArray\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"mCmd", "[", "\"\<size(hugeArray)\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.451145378796875*^9, 3.45114546240625*^9}, {
  3.45114551096875*^9, 3.451145548421875*^9}}],

Cell[BoxData["\<\"\\nans =\\n\\n    10    20    40\\n\\n\"\>"], "Output",
 CellChangeTimes->{{3.4511454550625*^9, 3.4511454656875*^9}, {
   3.451145524453125*^9, 3.451145548734375*^9}, 3.451145757296875*^9, 
   3.451146263515625*^9, 3.45114706365625*^9, 3.451913323459223*^9, 
   3.451913468694268*^9}]
}, Open  ]],

Cell["\<\
To assign a new variable name or pass anonymous values, you can use the more \
flexible\
\>", "Text",
 CellChangeTimes->{{3.4511454736875*^9, 3.451145504125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mPut", "[", 
   RowBox[{"\"\<mysum\>\"", ",", 
    RowBox[{"5", "+", "4"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"mCmd", "[", "\"\<disp(mysum);\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.451145472078125*^9, 3.45114547228125*^9}, {
  3.45114550521875*^9, 3.451145509734375*^9}, {3.451145556625*^9, 
  3.451145584703125*^9}}],

Cell[BoxData["\<\"     9\\n\\n\"\>"], "Output",
 CellChangeTimes->{3.4511455850625*^9, 3.4511457573125*^9, 
  3.45114626353125*^9, 3.451147063671875*^9, 3.451913324488831*^9, 
  3.451913470773587*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Special Cases", "Subtitle",
 CellChangeTimes->{{3.451146979234375*^9, 3.45114698196875*^9}}],

Cell["Singleton matrix dimensions", "Subsubtitle",
 CellChangeTimes->{{3.45114650565625*^9, 3.451146508890625*^9}}],

Cell["\<\
MATLAB has a stupid management of singleton dimensions: singleton (1-element) \
trailing dimensions are removed starting from dimension 3:\
\>", "Text",
 CellChangeTimes->{{3.45114651846875*^9, 3.4511465915625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mCmd", "[", 
  "\"\<size(0), size(zeros(2,1)), size(zeros(2,1,1)), size(zeros(1,1,2))\>\"",
   "]"}]], "Input",
 CellChangeTimes->{{3.451146592625*^9, 3.45114665678125*^9}, {3.451146738*^9, 
  3.451146743859375*^9}}],

Cell[BoxData["\<\"\\nans =\\n\\n     1     1\\n\\n\\nans =\\n\\n     2     \
1\\n\\n\\nans =\\n\\n     2     1\\n\\n\\nans =\\n\\n     1     1     2\\n\\n\
\"\>"], "Output",
 CellChangeTimes->{{3.45114665309375*^9, 3.451146656984375*^9}, {
   3.451146740625*^9, 3.45114674446875*^9}, 3.451147063671875*^9, 
   3.451913329171646*^9, 3.451913472404912*^9}]
}, Open  ]],

Cell["Keep this in mind when transferring data to MATLAB:", "Text",
 CellChangeTimes->{{3.451146666640625*^9, 3.451146758703125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "1", "}"}], ",", 
       RowBox[{"{", "2", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "3", "}"}], ",", 
       RowBox[{"{", "4", "}"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "a", "]"}], "\[IndentingNewLine]", 
 RowBox[{"mCmd", "[", 
  RowBox[{"\"\<size(\>\"", ",", "a", ",", "\"\<)\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.451146764640625*^9, 3.4511467964375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "2", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.451146644359375*^9, {3.45114678471875*^9, 3.4511467968125*^9}, 
   3.4511470636875*^9, 3.451913332822478*^9, 3.451913474988476*^9}],

Cell[BoxData["\<\"\\nans =\\n\\n     2     2\\n\\n\"\>"], "Output",
 CellChangeTimes->{
  3.451146644359375*^9, {3.45114678471875*^9, 3.4511467968125*^9}, 
   3.4511470636875*^9, 3.451913332822478*^9, 3.451913475198749*^9}]
}, Open  ]],

Cell[TextData[{
 "To get consistent behavior even for scalars (which for MATLAB are nothing \
different than 1x1 matrices), mConnect removes any trailing singleton \
dimensions when transferring data back to ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ", ",
 StyleBox["even for two-dimensional matrices!",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.4511468115625*^9, 3.4511469045625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"mCmd", "[", "\"\<a = rand(2,1); size(a)\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"mGet", "[", "\"\<a\>\"", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.451146918203125*^9, 3.45114695621875*^9}}],

Cell[BoxData["\<\"\\nans =\\n\\n     2     1\\n\\n\"\>"], "Output",
 CellChangeTimes->{3.451913342058814*^9, 3.451913476471854*^9}],

Cell[BoxData[
 RowBox[{"{", "2", "}"}]], "Output",
 CellChangeTimes->{3.451913342058814*^9, 3.451913476626401*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Special ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " characters"
}], "Subsubtitle",
 CellChangeTimes->{{3.451145974375*^9, 3.451145980203125*^9}}],

Cell[TextData[{
 "Special ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " symbols are translated into text form on the way to MATLAB, but by default \
NOT translated back, as this creates all kinds of problems when passing \
filenames:"
}], "Text",
 CellChangeTimes->{{3.45114501965625*^9, 3.451145048984375*^9}, {
  3.451145106453125*^9, 3.451145117203125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"s", " ", "=", " ", "\"\<MATLAB\[RegisteredTrademark]\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"mCmd", "[", 
  RowBox[{"\"\<disp(['Hello ' \>\"", ",", 
   RowBox[{"mVar", "[", "s", "]"}], ",", "\"\<]);\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.4511449604375*^9, 3.451145013015625*^9}, {
  3.451145056015625*^9, 3.45114509653125*^9}}],

Cell[BoxData["\<\"Hello MATLAB\\\\[RegisteredTrademark]\\n\"\>"], "Output",
 CellChangeTimes->{3.4511450599375*^9, 3.451145097140625*^9, 
  3.451145757234375*^9, 3.451145861*^9, 3.451146263546875*^9, 
  3.45114706371875*^9, 3.4519133454268*^9, 3.45191348009564*^9}]
}, Open  ]],

Cell[TextData[{
 "If you want these escape sequences to be interpreted as ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " special characters, use IntepretString:"
}], "Text",
 CellChangeTimes->{{3.451145809953125*^9, 3.4511458561875*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"s", " ", "=", " ", "\"\<MATLAB\[RegisteredTrademark]\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"mInterpretString", "[", 
  RowBox[{"mCmd", "[", 
   RowBox[{"\"\<disp(['Hello ' \>\"", ",", 
    RowBox[{"mVar", "[", "s", "]"}], ",", "\"\<]);\>\""}], "]"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.45114580509375*^9, 3.45114580571875*^9}, {
  3.451145863328125*^9, 3.451145921265625*^9}, {3.4511459536875*^9, 
  3.451145956046875*^9}, {3.451146007671875*^9, 3.451146077984375*^9}}],

Cell[BoxData["\<\"Hello MATLAB\[RegisteredTrademark]\\n\"\>"], "Output",
 CellChangeTimes->{{3.45114590603125*^9, 3.451145909671875*^9}, 
   3.451145956484375*^9, {3.45114601425*^9, 3.45114607853125*^9}, 
   3.4511462635625*^9, 3.451147063734375*^9, 3.451913346867909*^9, 
   3.451913481204065*^9}]
}, Open  ]],

Cell["\<\
File names containing backslashes are usually correctly handled by the \
default syntax:\
\>", "Text",
 CellChangeTimes->{{3.451146143140625*^9, 3.451146168953125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"filename", " ", "=", " ", "\"\<C:\\\\folder\\\\file.txt\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"mCmd", "[", 
  RowBox[{"\"\<disp(\>\"", ",", 
   RowBox[{"mVar", "[", "filename", "]"}], ",", "\"\<);\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.451146082375*^9, 3.451146157359375*^9}}],

Cell[BoxData["\<\"C:\\\\folder\\\\file.txt\\n\"\>"], "Output",
 CellChangeTimes->{{3.451146131234375*^9, 3.451146170375*^9}, 
   3.4511462635625*^9, 3.45114706375*^9, 3.451913349739302*^9, 
   3.451913482286729*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Class type", "Subsubtitle",
 CellChangeTimes->{{3.451146246390625*^9, 3.451146249015625*^9}}],

Cell["mClass returns the MATLAB class name of a specific variable:", "Text",
 CellChangeTimes->{{3.4511462740625*^9, 3.45114631628125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mCmd", "[", "\"\<m = rand(14,32);\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"mGetClass", "[", "\"\<m\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.451146249921875*^9, 3.451146342296875*^9}}],

Cell[BoxData["\<\"double\"\>"], "Output",
 CellChangeTimes->{3.451146342484375*^9, 3.451147063765625*^9, 
  3.451913351683613*^9, 3.451913485209243*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mCmd", "[", "\"\<s = 'mConnect works!';\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"mGetClass", "[", "\"\<s\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.451146344203125*^9, 3.4511463670625*^9}}],

Cell[BoxData["\<\"char\"\>"], "Output",
 CellChangeTimes->{3.45114636740625*^9, 3.45114706378125*^9, 
  3.451913352903495*^9, 3.451913485888203*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reference", "Subtitle",
 CellChangeTimes->{{3.451145713125*^9, 3.451145713953125*^9}}],

Cell["These are all functions in mConnect:", "Text",
 CellChangeTimes->{{3.451145723125*^9, 3.451145729203125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "mConnect`*"}]], "Input",
 CellChangeTimes->{{3.451145705859375*^9, 3.4511457075625*^9}}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["mConnect`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["mConnect`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["eng",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`eng"},
          ButtonNote->"mConnect`"], 
         ButtonBox["engGet",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`engGet"},
          ButtonNote->"mConnect`"], 
         ButtonBox["engPut",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`engPut"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mCmd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mCmd"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mGetLastError",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mGetLastError"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mPut",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mPut"},
          ButtonNote->"mConnect`"], 
         ButtonBox["SqueezeTrailing",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`SqueezeTrailing"},
          ButtonNote->"mConnect`"]},
        {
         ButtonBox["engClose",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`engClose"},
          ButtonNote->"mConnect`"], 
         ButtonBox["engIsOpen",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`engIsOpen"},
          ButtonNote->"mConnect`"], 
         ButtonBox["engVis",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`engVis"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mGet",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mGet"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mHide",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mHide"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mShow",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mShow"},
          ButtonNote->"mConnect`"], ""},
        {
         ButtonBox["engCmd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`engCmd"},
          ButtonNote->"mConnect`"], 
         ButtonBox["engOpen",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`engOpen"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mClearLastError",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mClearLastError"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mGetClass",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mGetClass"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mInterpretString",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mInterpretString"},
          ButtonNote->"mConnect`"], 
         ButtonBox["mVar",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3451920688-1839194", "mConnect`mVar"},
          ButtonNote->"mConnect`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.1357142857142857]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.451913488460928*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{1140, 821},
WindowMargins->{{44, Automatic}, {1, Automatic}},
ShowSelection->True,
FrontEndVersion->"7.0 for Microsoft Windows (64-bit) (November 10, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "PastelColor.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 154, 2, 73, "Title"],
Cell[724, 26, 98, 1, 36, "Subtitle"],
Cell[825, 29, 230, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[1080, 37, 92, 1, 36, "Subtitle"],
Cell[1175, 40, 219, 4, 29, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1431, 49, 94, 1, 36, "Subtitle"],
Cell[1528, 52, 96, 1, 29, "Subsubtitle"],
Cell[1627, 55, 719, 15, 83, "Text"],
Cell[CellGroupData[{
Cell[2371, 74, 94, 1, 29, "Subsubtitle"],
Cell[2468, 77, 1172, 21, 155, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3689, 104, 256, 3, 36, "Subtitle"],
Cell[3948, 109, 248, 7, 29, "Text"],
Cell[4199, 118, 283, 5, 41, "Input"],
Cell[4485, 125, 125, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[4635, 130, 168, 3, 41, "Input"],
Cell[4806, 135, 171, 4, 21, "Message"]
}, Open  ]],
Cell[4992, 142, 179, 4, 29, "Text"],
Cell[5174, 148, 118, 2, 41, "Input"],
Cell[5295, 152, 212, 4, 29, "Text"],
Cell[5510, 158, 119, 2, 41, "Input"],
Cell[5632, 162, 98, 1, 29, "Text"],
Cell[5733, 165, 120, 2, 41, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5890, 172, 149, 2, 36, "Subtitle"],
Cell[6042, 176, 213, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[6280, 184, 154, 2, 41, "Input"],
Cell[6437, 188, 305, 6, 21, "Message"],
Cell[6745, 196, 233, 3, 60, "Output"]
}, Open  ]],
Cell[6993, 202, 186, 2, 29, "Text"],
Cell[CellGroupData[{
Cell[7204, 208, 146, 2, 41, "Input"],
Cell[7353, 212, 212, 4, 21, "Message"],
Cell[7568, 218, 208, 2, 43, "Print"],
Cell[7779, 222, 225, 4, 21, "Message"],
Cell[8007, 228, 98, 1, 23, "Print"],
Cell[8108, 231, 230, 3, 40, "Output"]
}, Open  ]],
Cell[8353, 237, 201, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[8579, 245, 304, 5, 82, "Input"],
Cell[8886, 252, 234, 3, 60, "Output"],
Cell[9123, 257, 124, 2, 40, "Output"],
Cell[9250, 261, 124, 2, 40, "Output"]
}, Open  ]],
Cell[9389, 266, 348, 7, 29, "Text"],
Cell[CellGroupData[{
Cell[9762, 277, 385, 10, 62, "Input"],
Cell[10150, 289, 213, 3, 98, "Output"]
}, Open  ]],
Cell[10378, 295, 218, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[10621, 303, 314, 7, 62, "Input"],
Cell[10938, 312, 232, 3, 60, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11219, 321, 212, 3, 36, "Subtitle"],
Cell[11434, 326, 166, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[11625, 333, 390, 8, 62, "Input"],
Cell[12018, 343, 198, 3, 40, "Output"],
Cell[12219, 348, 907, 22, 53, "Output"]
}, Open  ]],
Cell[13141, 373, 129, 1, 29, "Text"],
Cell[13273, 376, 200, 3, 41, "Input"],
Cell[13476, 381, 268, 5, 29, "Text"],
Cell[CellGroupData[{
Cell[13769, 390, 214, 5, 41, "Input"],
Cell[13986, 397, 204, 4, 40, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14239, 407, 292, 8, 36, "Subtitle"],
Cell[14534, 417, 225, 5, 29, "Text"],
Cell[CellGroupData[{
Cell[14784, 426, 225, 5, 62, "Input"],
Cell[15012, 433, 204, 3, 40, "Output"]
}, Open  ]],
Cell[15231, 439, 142, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[15398, 444, 272, 5, 62, "Input"],
Cell[15673, 451, 322, 7, 21, "Message"],
Cell[15998, 460, 102, 1, 40, "Output"],
Cell[16103, 463, 324, 7, 21, "Message"],
Cell[16430, 472, 104, 1, 40, "Output"]
}, Open  ]],
Cell[16549, 476, 152, 3, 29, "Text"],
Cell[16704, 481, 153, 3, 41, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16894, 489, 245, 7, 36, "Subtitle"],
Cell[17142, 498, 545, 11, 65, "Text"],
Cell[CellGroupData[{
Cell[17712, 513, 510, 13, 82, "Input"],
Cell[18225, 528, 302, 4, 136, "Output"]
}, Open  ]],
Cell[18542, 535, 172, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[18739, 543, 374, 8, 62, "Input"],
Cell[19116, 553, 200, 3, 79, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19365, 562, 98, 1, 36, "Subtitle"],
Cell[19466, 565, 115, 1, 29, "Subsubtitle"],
Cell[19584, 568, 225, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[19834, 576, 240, 5, 41, "Input"],
Cell[20077, 583, 354, 5, 421, "Output"]
}, Open  ]],
Cell[20446, 591, 133, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[20604, 596, 588, 17, 82, "Input"],
Cell[21195, 615, 239, 5, 40, "Output"],
Cell[21437, 622, 223, 3, 136, "Output"]
}, Open  ]],
Cell[21675, 628, 411, 10, 47, "Text"],
Cell[CellGroupData[{
Cell[22111, 642, 259, 5, 62, "Input"],
Cell[22373, 649, 131, 1, 136, "Output"],
Cell[22507, 652, 114, 2, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22658, 659, 174, 6, 29, "Subsubtitle"],
Cell[22835, 667, 369, 9, 29, "Text"],
Cell[CellGroupData[{
Cell[23229, 680, 384, 8, 62, "Input"],
Cell[23616, 690, 265, 3, 60, "Output"]
}, Open  ]],
Cell[23896, 696, 245, 6, 29, "Text"],
Cell[CellGroupData[{
Cell[24166, 706, 526, 11, 62, "Input"],
Cell[24695, 719, 298, 4, 60, "Output"]
}, Open  ]],
Cell[25008, 726, 178, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[25211, 734, 337, 8, 62, "Input"],
Cell[25551, 744, 215, 3, 60, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25815, 753, 99, 1, 29, "Subsubtitle"],
Cell[25917, 756, 139, 1, 32, "Text"],
Cell[CellGroupData[{
Cell[26081, 761, 240, 5, 56, "Input"],
Cell[26324, 768, 152, 2, 38, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26513, 775, 244, 5, 56, "Input"],
Cell[26760, 782, 148, 2, 38, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26969, 791, 92, 1, 38, "Subtitle"],
Cell[27064, 794, 115, 1, 32, "Text"],
Cell[CellGroupData[{
Cell[27204, 799, 117, 2, 38, "Input"],
Cell[27324, 803, 4132, 100, 111, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
